import java.util.* ;
import java.awt.* ;

class Controler {
  private class Event {
    Poly p ; Point pt ;

    Event (Poly p, Point pt) {
      this.p = Poly.copy(p) ;
      this.pt = pt ;
    }
    Event (Poly p) { this(p, null) ; }

    void show(PolyShow ps) {
      if (pt == null) {
        ps.show(p) ;
      } else {
        ps.show(p, pt) ;
      }
    }
  }

  private LinkedList<Event> past ;
  private LinkedList<Event> future ;
  private Event present ;
  private PolyShow ps ;

  Controler (PolyShow ps) {
    past = new LinkedList<Event> () ;
    future = new LinkedList<Event> () ;
    this.ps = ps ;
  }

  synchronized void show(java.awt.Point pt) {
    ps.show(pt) ;
  }

  private void show(Event e) {
    if (future.size() == 0) {
      if (present != null)  past.addLast(present) ;
      present = e ;
      e.show(ps) ;
    } else {
      future.addLast(e) ;
    }
    // Wait once,
    try {
        wait() ;
    } catch (InterruptedException exc) {  }
  }

  synchronized void show(Poly p, Point pt) {
    show(new Event (p,pt)) ;
  }

  synchronized void show(Poly p) {
    show(new Event (p)) ;
  }

  synchronized void step() {
    if (future.size() > 0) {
      if (present != null)  past.addLast(present) ;
      present = future.removeFirst() ;
      present.show(ps) ;
    } else {
      notify() ;
    }
  }

  synchronized void back() {
    if (past.size() > 0) {
      if (present != null)  future.addFirst(present) ;
      present = past.removeLast() ;
      present.show(ps) ;
    }
  }
}
