import java.awt.* ;
import java.awt.event.* ;
import java.util.* ;

// Classe pour afficher le buffer bufimg dans la fen^etre
class ImgCanvas extends Canvas {
  final static int R=6 ;
  Image bufimg ;
  Graphics graph ;
  int height, width ;
  Cell<Point> cell ;
  Enabler afterTwo ;
  boolean modeOne = false ;

  public void resetSize(Dimension sz) {
    width = sz.height ; height = sz.width ;
    Image old = bufimg ;
    bufimg = createImage (sz.width, sz.height) ;
    graph =  bufimg.getGraphics() ;
    graph.drawImage(old, 0, 0, this) ;
    if (poly != null) {
      zyva(poly) ;
    }
  }

  ImgCanvas (int height, int width, Cell<Point> cell, Enabler enabler,
	     boolean alsoInput) {
    bufimg = null ;
    this.height = height ;
    this.width = width ;
    this.cell = cell ;
    this.afterTwo = enabler ;
    setSize (height, width) ;
    if (alsoInput) startLine(0) ;
    final ImgCanvas me = this ;
    addComponentListener
      (new ComponentAdapter () {
	  public void componentResized(ComponentEvent e) {
            Dimension sz =  me.getSize() ;
            me.resetSize(sz) ;
	  }
	}) ;

  }

  void restart() {
    clear() ;
    poly = null ;
    allPoints.clear() ;
    startLine(0) ;
    modeOne = false ;
    cell.set(null) ;
  }

  void startLine(int nread) {
    p1 = null ; this.nread = nread ;
    enableEvents(MouseEvent.MOUSE_PRESSED | MouseEvent.MOUSE_RELEASED);
    enableEvents(MouseEvent.MOUSE_DRAGGED);
  }

  void clear() {
    if (graph != null) {
      graph.clearRect(0, 0, height, width) ;
      repaint() ;
    }
  }

  synchronized void closeLine() {
    cell.set(null) ;
    disableEvents(MouseEvent.MOUSE_PRESSED | MouseEvent.MOUSE_RELEASED);
    disableEvents(MouseEvent.MOUSE_DRAGGED);
    zyva(p1, startP) ;
    repaint() ;
    startLine(nread) ;
    modeOne = true ;
  }


  public void paint (Graphics g) {
    if (bufimg != null) {
      g.drawImage(bufimg, 0, 0, this) ;
    }
  }

  // Pour ne pas que sa clignotte en gris quand ,ca rame :
  public void update (Graphics g) {
    paint (g) ;
  }

  // Dessins
  Point p1, p2, startP;

  void zyva(int x, int y) {
    graph.fillOval(x-R, y-R, 2*R, 2*R) ;
  }

  void zyva(Point p) {
    zyva(p.x, p.y) ;
  }

  private Point move(Point p, int dx, int dy, double r) {
    double q = r / Math.sqrt(dx*dx+dy*dy) ;
    return new Point(p.x+(int)(dx*q), p.y+(int)(dy*q)) ;
  }


  void arrow(Point p1, Point p2) {
    graph.drawLine(p1.x, p1.y, p2.x, p2.y) ;
    Point t1 = move(p2, p1.x-p2.x, p1.y-p2.y, R) ;
    Point t0 = move(t1, p1.x-p2.x, p1.y-p2.y, 2*R) ;
    Point t2 = move(t0, p2.y-p1.y,  p1.x-p2.x, 2*R) ;
    Point t3 = move(t0, p1.y-p2.y,  p2.x-p1.x, 2*R) ;
    graph.fillPolygon
      (new int [] {t1.x, t2.x, t3.x},
       new int [] {t1.y, t2.y, t3.y}, 3) ;
  }

  void arrow(Point p1, Point p2, Color c) {
    Color old = graph.getColor() ;
    graph.setColor(c) ;
    arrow(p1,p2) ;
    graph.setColor(old) ;
  }

  void zyva(Point p1, Point p2) {
    arrow(p1, p2) ; zyva(p2) ;
  }


  void zyva(Point p1, Point p2, int side) {
    Color c = Color.MAGENTA ;
    if (side < 0) {
      c = Color.BLUE ;
    } else if (side > 0) {
      c = Color.RED ;
    }
    arrow(p1, p2, c) ;
    zyva(p2) ;
  }

  private PolyIterator poly  = null ;
  private ArrayList<Point> allPoints = new ArrayList<Point>() ;

  void zyva(Collection<Point> col) {
    clear() ;
    allPoints.addAll(col) ;
    showAllPoints() ;
    repaint() ;
  }

  void show(Point pt) {
    allPoints.add(pt) ;
    showAllPoints() ;
    repaint() ;
  }

  void showAllPoints() {
    Color old = graph.getColor() ;
    graph.setColor(Color.GRAY) ;
    for (Point pt : allPoints) {
      zyva(pt) ;
    }
    graph.setColor(old) ;
  }

  void show(PolyIterator in) {
    clear() ;
    zyva(in) ;
    repaint() ;
  }

  void zyva(PolyIterator in) {
    showAllPoints() ;
    poly = in ;
    Point p1 = in.next() ;
    Point p2 = p1 ;
    do {
      Point p3 = in.next() ;
      zyva(p2, p3) ;
      p2 = p3 ;
    } while (p2 != p1) ;
  }

  void show(PolyIterator in, Point q) {
    clear() ;
    showAllPoints() ;
    zyva(in, q) ;
    repaint() ;
  }

  void zyva(PolyIterator in, Point q) {
    zyva(q) ;
    int side = in.getSide(q) ;
    Point p1 = in.next() ;
    Point p2 = p1 ;
    do {
      int s2 = in.getSide(q) ;
      Point p3 = in.next() ;
      zyva(p2, p3, side) ;
      p2 = p3 ;
      if (side <=0 && s2 > 0) {
	arrow(p3,q, Color.GRAY) ;
      } else if (side > 0 && s2 <= 0) {
	arrow(q,p3,Color.GRAY) ;
      }
      side = s2 ;
    } while (p2 != p1) ;
  }

  // Les evenements souris
  private int nread ;

  void acceptPoint(Point p) {
    cell.set(p) ; nread++ ;
    allPoints.add(p) ;
    if (nread == 2) afterTwo.setEnabled(true) ;

  }

  synchronized void pressed(MouseEvent e) {
    if (modeOne) {
      p1 = e.getPoint();
      graph.setXORMode(Color.white);
      zyva(poly) ;
      zyva(poly,p1) ;
    } else {
      if (p1 == null) {
        p1 = e.getPoint() ;
        startP = p1 ;
        zyva(p1) ;
	acceptPoint(p1) ;
      }
      graph.setXORMode(Color.white);
      p2 = e.getPoint();
      zyva(p1, p2) ;
    }
    repaint() ;
  }

  synchronized void released(MouseEvent e) {
    if (modeOne) {
      zyva(poly, p1) ;
      Point p = e.getPoint() ;
      graph.setPaintMode();
      zyva(poly,p) ;
      repaint() ;
      acceptPoint(p) ;
    } else {
      zyva(p1, p2) ;
      p2 = e.getPoint();
      graph.setColor(Color.black);
      graph.setPaintMode();
      zyva(p1, p2) ;
      if (p1.x == p2.x && p1.y == p2.y) {
        repaint() ;
      } else {
        p1 = p2 ;
        repaint() ;
	acceptPoint(p1) ;
      }
    }
  }

  
  protected void processMouseEvent(MouseEvent e) {
    if (e.getID() == MouseEvent.MOUSE_PRESSED)
      pressed(e);
    else if (e.getID() == MouseEvent.MOUSE_RELEASED)
      released(e);
  }

  void dragged(MouseEvent e) {
    if (modeOne) {
      zyva(poly, p1) ;
      p1 = e.getPoint() ;
      zyva(poly, p1) ;
    } else {
      zyva(p1, p2) ;
      p2 = e.getPoint() ;
      zyva(p1, p2) ;
    }
    repaint() ;
  }

  protected void processMouseMotionEvent(MouseEvent e) {
    if (e.getID() == MouseEvent.MOUSE_DRAGGED)
      dragged(e);
  }
}

