import java.awt.* ;
import java.io.* ;
import java.util.* ;

class PointFileReader implements PointReader {
  private Scanner scanner ;

  PointFileReader (String name) {
    try {
      File f = new File(name) ;
      scanner = new Scanner(f) ;
    } catch (FileNotFoundException e) {
      System.err.println("Cannot build PointFileReader: " + e.getMessage()) ;
      System.exit(2) ;
    }
  }

  
  public Point read() {
    try {
      int x = scanner.nextInt() ;
      int y = scanner.nextInt() ;
      return new Point(x, y) ;
    } catch (NoSuchElementException e) {
      scanner.close() ;
      return null ;
    }
  }
}
