import java.util.* ;
import java.awt.* ;
import java.awt.event.* ;
import java.awt.image.* ;
import java.io.* ;

class PolyShow extends Frame implements PointReader {

  final ImgCanvas imgDisplayer ; // Composant awt affichant bufimg

  final int height = 700 ;
  final int width = 400 ;

  private Cell<Point> cell ;
  final Controler ctrl ;

  PolyShow() { this(true) ; }

  PolyShow(boolean alsoInput) {
    super("PolyShow") ;
    setBackground(Color.WHITE) ;
    // Pour quitter si on ferme la fen^etre :
    cell = new Cell<Point>() ;
    addWindowListener
      (new WindowAdapter () {
	  public void windowClosing(WindowEvent e) {
	    System.exit(0) ;
	  }
	}) ;
    // Divers trucs pour communiquer avec le imgDisplayer
    final Enabler closeEnabler = new Enabler () ;
    final Enabler restartEnabler = new Enabler () ;

    // Pour afficher l'image qui sera stock'ee dans bufimg :
    imgDisplayer =
      new ImgCanvas (height, width, cell, closeEnabler,
		     alsoInput) ;

    setLayout(new BorderLayout());
    add("Center", imgDisplayer) ;

    if (alsoInput) {
      Panel buttons = new Panel () ;
      Button close = new Button("Close") ;
      buttons.add(close) ;
      closeEnabler.setButton(close) ;
      close.addActionListener
	(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	      restartEnabler.setEnabled(true) ;
	      closeEnabler.setEnabled(false) ;
	      imgDisplayer.closeLine() ;
	    }
	  }) ;
      closeEnabler.setEnabled(false) ;


      Button restart = new Button("Again") ;
      buttons.add(restart) ;
      restartEnabler.setButton(restart) ;
      restart.addActionListener
	(new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	      restartEnabler.setEnabled(false) ;
	      imgDisplayer.restart() ;
	    }
	  }) ;
      restartEnabler.setEnabled(false) ;
      add("North", buttons) ;
      ctrl = null ;
    } else {
      ctrl = new Controler(this) ;
      Panel ctrlButtons = new Panel () ;
      Button step = new Button("Step") ;
      ctrlButtons.add(step) ;
      step.addActionListener
        (new ActionListener() {
            public void actionPerformed(ActionEvent e) {
              ctrl.step() ;
            }
          }) ;
      Button back = new Button("Back") ;
      ctrlButtons.add(back) ;
      back.addActionListener
        (new ActionListener() {
            public void actionPerformed(ActionEvent e) {
              ctrl.back() ;
            }
          }) ;
      add("North", ctrlButtons) ;
    }

    // Calculer les dimensions et rendre visible :
    pack () ;
    setLocation(100,100) ;
    setVisible(true) ;

    // Pour dessiner dans la fen^etre et ^etre capable de la redessiner,
    //   on dessine dans un buffer qui est copi'e 
    //   dans la fenetre.
    final Image bufimg = createImage (height, width) ;
    final Graphics graph =  bufimg.getGraphics() ;
    // createImage () renvoie null tant qu'on a pas fait :
    //   setVisible (true) ; On peut maintenant donner `a imgDisplayer
    //   le buffer qu'il doit afficher :
    imgDisplayer.bufimg = bufimg ;
    imgDisplayer.graph = graph ;    
  }

  void ferme() {
    Component cmp[] = this.getComponents();
    for(int i=0;i<cmp.length;i++) {
      if(cmp[i] != null) {
        this.getInputContext().removeNotify(cmp[i]);
      }
    }
    this.getInputContext().removeNotify(this);
    this.removeNotify();
    dispose() ;
  }

  void show(Point pt) {
    imgDisplayer.show(pt) ;
  }

  void show(Poly p) {
    imgDisplayer.show(p.getIterator()) ;
  }

  void show(Poly p, Point pt) {
    imgDisplayer.show(p.getIterator(), pt) ;
  }

  public Point read() {
    Point r = cell.get() ;
    return r ;
  }
}


